;===================================================================
;  FileCompare via Drag'n'Drop
;   v.2018-12-28, draft by kero (win7-32)
;===================================================================
;[masm32]
  __UNICODE__  equ  1
;===================================================================
;[proc]
; GetStringFileName
; StringToLog
; FileToLog
; htodw
; BackSlash
; GetAllocGran
; ThreadBeep
; BeepThreadIf
; BeepIf
; FileSizeEx
; ReadFirstLastByte
; ThreadMakeFile
; Proc0: FilePointerEx+
; Proc1: MMF+RtlCompareMemory+
; CreateProc
; ProcE: external app
; KillTimerProc
; ThreadProc
; SaveSettings
; RestoreSettings
; ClearProc
; SetCaption
; OnSize
; SubClass2
; SubClass
; DragDropUAC
; OnSetCursor
; EnumThreadWndProc
; OnTimer
; OnCommand
; OnSysCommand
; OnPaint
; OnInit
; DlgProc

;===================================================================

.386
;;.486
.model flat,stdcall
option casemap:none

.const
  id                                  equ       100
  ii                                  equ      2000
;
  SC_CUSTOM                           equ     0e000h
;
  WM_COPYGLOBALDATA                   equ      0049h
  WM_SYSMENU                          equ      0313h  ; WM_TASKBUTTONMENU
;
  CREATE_NEW                          equ         1
  CREATE_ALWAYS                       equ         2
  OPEN_EXISTING                       equ         3
  OPEN_ALWAYS                         equ         4
  TRUNCATE_EXISTING                   equ         5
;
  FILE_ATTRIBUTE_READONLY             equ         1h
  FILE_ATTRIBUTE_HIDDEN               equ         2h
  FILE_ATTRIBUTE_SYSTEM               equ         4h
;?
  FILE_ATTRIBUTE_DIRECTORY            equ        10h ; -- (not SetFileAttributes)
  FILE_ATTRIBUTE_ARCHIVE              equ        20h
  FILE_ATTRIBUTE_DEVICE               equ        40h ; --
  FILE_ATTRIBUTE_NORMAL               equ        80h
  FILE_ATTRIBUTE_TEMPORARY            equ       100h
  FILE_ATTRIBUTE_SPARSE_FILE          equ       200h ; --
  FILE_ATTRIBUTE_REPARSE_POINT        equ       400h ; --
  FILE_ATTRIBUTE_COMPRESSED           equ       800h ; --
  FILE_ATTRIBUTE_OFFLINE              equ      1000h
  FILE_ATTRIBUTE_NOT_CONTENT_INDEXED  equ      2000h
  FILE_ATTRIBUTE_ENCRYPTED            equ      4000h ; --
;?
  FILE_ATTRIBUTE_VIRTUAL              equ     10000h
;?
  FILE_FLAG_OPEN_NO_RECALL            equ  00100000h
  FILE_FLAG_OPEN_REPARSE_POINT        equ  00200000h
;?
  FILE_FLAG_POSIX_SEMANTICS           equ  01000000h
  FILE_FLAG_BACKUP_SEMANTICS          equ  02000000h
  FILE_FLAG_DELETE_ON_CLOSE           equ  04000000h
  FILE_FLAG_SEQUENTIAL_SCAN           equ  08000000h
  FILE_FLAG_RANDOM_ACCESS             equ  10000000h
  FILE_FLAG_NO_BUFFERING              equ  20000000h
  FILE_FLAG_OVERLAPPED                equ  40000000h
  FILE_FLAG_WRITE_THROUGH             equ  80000000h
;
  FILE_SUPPORTS_SPARSE_FILES          equ  00000040h
  FILE_SUPPORTS_REPARSE_POINTS        equ  00000080h
  FILE_SUPPORTS_REMOTE_STORAGE        equ  00000100h
  FILE_SUPPORTS_OBJECT_IDS            equ  00010000h
  FILE_SUPPORTS_ENCRYPTION            equ  00020000h
;
;?  FSCTL_SET_COMPRESSION               equ  
;?  FSCTL_SET_REPARSE_POINT             equ  
  FSCTL_SET_SPARSE                    equ  000900C4h
  FSCTL_QUERY_ALLOCATED_RANGES        equ  000940CFh
  FSCTL_SET_ZERO_DATA                 equ  000980C8h
;
  FILE_BEGIN                          equ         0
  FILE_CURRENT                        equ         1
  FILE_END                            equ         2
;
  CREATE_NO_WINDOW                    equ  08000000h
;
  STILL_ACTIVE                        equ       259
  INFINITE                            equ        -1
  WAIT_FAILED                         equ        -1
  WAIT_OBJECT_0                       equ         0
  WAIT_ABANDONED                      equ        80h
  WAIT_TIMEOUT                        equ       102h
  SEC_NOCACHE                         equ  10000000h

include windows.inc
include c:\masm32\macros\macros.asm

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib ntdll
inclib kernel32
inclib user32
inclib shell32
inclib shlwapi
inclib gdi32
inclib comctl32

SYSTEM_INFO struct
  wProcessorArchitecture       WORD  ?
  wReserved                    WORD  ?
  dwPageSize                   DWORD ?
  lpMinimumApplicationAddress  DWORD ?
  lpMaximumApplicationAddress  DWORD ?
  dwActiveProcessorMask        DWORD ?
  dwNumberOfProcessors         DWORD ?
  dwProcessorType              DWORD ?
  dwAllocationGranularity      DWORD ?
  wProcessorLevel              WORD  ?
  wProcessorRevision           WORD  ?
SYSTEM_INFO ends

LARGE_INTEGER_ union
  struct
   LowPart   DWORD ?
   HighPart  DWORD ?
  ends
 QuadPart  QWORD ?
LARGE_INTEGER_ ends

FILE_ZERO_DATA_INFORMATION struct
  FileOffset           LARGE_INTEGER_ <>
  BeyondFinalZero      LARGE_INTEGER_ <>
FILE_ZERO_DATA_INFORMATION ends

FILE_ALLOCATED_RANGE_BUFFER struct
  FileOffset           LARGE_INTEGER_ <>
  Length_              LARGE_INTEGER_ <>
FILE_ALLOCATED_RANGE_BUFFER ends

COMBOBOXINFO_ struct
  cbSize          DWORD ?
  rcItem          RECT <>
  rcButton        RECT <>
  stateButton     DWORD ?
  hwndCombo       HWND ?
  hwndItem        HWND ?
  hwndList        HWND ?
COMBOBOXINFO_ ends

WINDOWINFOEX struct
  cbSize           DWORD ?
  rcWindow         RECT <>
  rcClient         RECT <>
  dwStyle          DWORD ?
  dwExStyle        DWORD ?
  dwWindowStatus   DWORD ?
  cxWindowBorders  UINT  ?
  cyWindowBorders  UINT  ?
  atomWindowType   ATOM  ?
  wCreatorVersion  WORD  ?
  t1               TCHAR MAX_PATH dup(?)
  t2               TCHAR MAX_PATH dup(?)
WINDOWINFOEX ends


.data
 _2next    TCHAR 13,10
 _next     TCHAR 13,10
 _0        TCHAR 0
 
.data?
  hThread2 HANDLE ?
  hThread3 HANDLE ? 
  hbrush   HBRUSH ? 
  hinst    dd ?
  xsize    dd ?
  beep_hi  dd ?
  beep_lo  dd ?
  beep_ms  dd ?
  procN    dd ?
  procMax  dd ?
  granul   dd ?
  uacdd    dd ?
  alpha    dd ?
  droped   dd ?
  ch39     dd ?
  trig     dd ?
  minim    dd ?
  tm2      dd ?
  tm3      dd ?
  tid      dd ?
  flg      dd ?
  edx_     dd ?
  dwCreationDisposition dd ?  
  rect     RECT <>
  L_I3     LARGE_INTEGER_ <>
  L_I2     LARGE_INTEGER_ <>
  L_I1     LARGE_INTEGER_ <>
  L_I      LARGE_INTEGER_ <>
  buf_top  TCHAR MAX_PATH dup(?)
  buf_low  TCHAR MAX_PATH dup(?)

.code

;===================================================================

GetStringFileName proc num:DWORD,lpbuf:DWORD

  local	buf[MAX_PATH]:TCHAR

  invoke GetModuleFileName,0,lpbuf,MAX_PATH-1
  invoke PathRemoveExtension,lpbuf
  invoke LoadString,hinst,num,addr buf,MAX_PATH-1
  invoke lstrcat,lpbuf,addr buf
  ret
GetStringFileName endp

;===================================================================

StringToLog proc uses ebx edi esi lpbuf:DWORD

  local	bytes:DWORD
  local	buf[MAX_PATH]:TCHAR
  
  invoke GetStringFileName,62,addr buf
  invoke CreateFile,addr buf,
                    GENERIC_READ or GENERIC_WRITE,
                    FILE_SHARE_READ or FILE_SHARE_WRITE,
                    0,
                    OPEN_ALWAYS,
                    FILE_ATTRIBUTE_NORMAL,
                    0

  .if eax!=INVALID_HANDLE_VALUE
    mov esi,eax
    invoke SetFilePointer,esi,
                          0,
                          0,
                          FILE_END

    invoke lstrcpy,addr buf,lpbuf
    invoke lstrcat,addr buf,offset _next
    invoke lstrlen,addr buf
    mov edx,sizeof(TCHAR)
    .if edx==2
      add eax,eax
    .endif
    mov bytes,eax
    invoke WriteFile,esi,
                     addr buf,
                     bytes,
                     addr bytes,
                     0

    invoke CloseHandle,esi
  .endif
  ret
StringToLog endp

;===================================================================

FileToLog proc uses ebx hWnd:HWND

  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR

  invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1
  invoke lstrcmpi,addr buf,offset buf_top
  mov ebx,eax
  invoke GetDlgItemText,hWnd,id+20,addr buf2,MAX_PATH-1
  invoke lstrcmpi,addr buf2,offset buf_low
  .if eax!=0 || ebx!=0
    invoke lstrcpy,offset buf_top,addr buf
    invoke lstrcpy,offset buf_low,addr buf2
    invoke StringToLog,addr buf
    invoke StringToLog,addr buf2    
  .endif
  ret
FileToLog endp

;===================================================================
; (From: masm32\m32lib\htodw.asm)

htodw proc uses ebx edi esi String:DWORD

; -----------------------------------
; Convert hex string into dword value
; Return value in eax
; -----------------------------------

  push ebx
  push esi
  push edi
  mov edi,String
  mov esi,String 
  ALIGN 4
again:  
  mov al,[edi]
  inc edi
  or  al,al
  jnz again
  sub esi,edi
  xor ebx,ebx
  add edi,esi
  xor edx,edx
  not esi             ;esi = lenth
  .while esi != 0
    mov al, [edi]
    cmp al,'A'
    jb figure
    sub al,'a'-10
    adc dl,0
    shl dl,5          ;if cf set we get it bl 20h else - 0
    add al,dl
    jmp next
figure: 
    sub al,'0'
next:  
    lea ecx,[esi-1]
    and eax, 0Fh
    shl ecx,2         ;mul ecx by log 16(2)
    shl eax,cl        ;eax * 2^ecx
    add ebx, eax
    inc edi
    dec esi
  .endw
  mov eax,ebx
  pop edi
  pop esi
  pop ebx
  ret
htodw endp

;===================================================================

BackSlash proc uses ebx edi esi hWnd:HWND,lpbuf:DWORD

  local buf[MAX_PATH]:TCHAR
  local bu[2]:TCHAR
  local ch44:DWORD

  invoke IsDlgButtonChecked,hWnd,id+44
  mov ch44,eax                           ; un/checked: '\' / '\\'

  lea ebx,bu
  mov edi,lpbuf
  xor esi,esi
  mov TCHAR ptr[buf],0
  .while TRUE
    mov eax,sizeof TCHAR
    .if eax==1
      mov dl,byte ptr[edi+(sizeof TCHAR)*esi]
      mov byte ptr[ebx],dl
    .else ; if eax==2
      mov dx,word ptr[edi+(sizeof TCHAR)*esi]
      mov word ptr[ebx],dx
    .endif
    mov TCHAR ptr[ebx+(sizeof TCHAR)],0
    invoke lstrcat,addr buf,ebx
  .break .if TCHAR ptr[edi+(sizeof TCHAR)*esi]==0
    .if TCHAR ptr[edi+(sizeof TCHAR)*esi]=='\'
      mov ecx,esi
      inc ecx
      .if TCHAR ptr[edi+(sizeof TCHAR)*ecx]=='\'
        .if ch44==0
          inc esi
        .endif
      .else
        .if ch44!=0
          mov edx,esi
          dec edx
          .if TCHAR ptr[edi+(sizeof TCHAR)*edx]!='\'
            invoke lstrcat,addr buf,ebx
          .endif
        .endif
      .endif
    .endif
    inc esi
  .endw
  invoke lstrcpy,lpbuf,addr buf
  ret
BackSlash endp

;===================================================================

GetAllocGran proc

  local S_I:SYSTEM_INFO

  invoke GetSystemInfo,addr S_I
  mov eax,S_I.dwAllocationGranularity
  ret
GetAllocGran endp

;===================================================================

ThreadBeep proc freq:DWORD

  invoke Beep,freq,beep_ms
  ret
ThreadBeep endp

;===================================================================

BeepThreadIf proc hWnd:HWND,freq:DWORD

  invoke IsDlgButtonChecked,hWnd,id+32
  .if eax==BST_CHECKED && freq!=0
    invoke CreateThread,0,0,offset ThreadBeep,freq,0,0
    invoke CloseHandle,eax
  .endif
  ret
BeepThreadIf endp

;===================================================================

BeepIf proc hWnd:HWND,freq:DWORD,dur:DWORD

  invoke IsDlgButtonChecked,hWnd,id+32
  .if eax==BST_CHECKED
    invoke Beep,freq,dur
  .endif
  ret
BeepIf endp

;===================================================================

FileSizeEx proc uses ebx edi lpbuf:DWORD,lpLI:DWORD
  xor edi,edi
  invoke CreateFile,lpbuf,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_NORMAL,
                    0 
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke GetFileSizeEx,ebx,lpLI
    .if eax==0
      inc edi
    .endif
    invoke CloseHandle,ebx
  .else
    inc edi
    inc edi
  .endif
  mov eax,edi  ; (0 - succeeds; 1 - GetFileSizeEx failS; 2 - INVALID_HANDLE_VALUE failS)
  ret
FileSizeEx endp

;===================================================================

ReadFirstLastByte proc uses ebx hWnd:HWND,lpbuf:DWORD

  local	bytes:DWORD
  local bu[1]:BYTE
  local buf[MAX_PATH]:TCHAR

  xor eax,eax
  inc eax
  mov bytes,eax

  invoke CreateFile,lpbuf,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_NORMAL,
                    0 
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointerEx,ebx,
                            0,
                            0,
                            0,
                            FILE_BEGIN
    invoke ReadFile,ebx,
                    addr bu,
                    bytes,
                    addr bytes,
                    0
    xor eax,eax
    mov al,byte ptr[bu]
    fn wsprintf,addr buf,"%2.2lX",eax
    invoke SetDlgItemText,hWnd,id+26,addr buf
    invoke SetFilePointerEx,ebx,
                            0ffffffffh, ; -1
                            0ffffffffh, ; -1
                            0,
                            FILE_END
    invoke ReadFile,ebx,
                    addr bu,
                    bytes,
                    addr bytes,
                    0
    xor eax,eax
    mov al,byte ptr[bu]
    fn wsprintf,addr buf,"%2.2lX",eax
    invoke SetDlgItemText,hWnd,id+25,addr buf
    invoke CloseHandle,ebx
  .endif
  ret
ReadFirstLastByte endp

;===================================================================

ThreadMakeFile proc uses ebx edi esi hWnd:HWND

  local fzdi:FILE_ZERO_DATA_INFORMATION
  local bhfi:BY_HANDLE_FILE_INFORMATION
  local queryRange:FILE_ALLOCATED_RANGE_BUFFER
  local li:LARGE_INTEGER_
  local hdd:DWORD  
  local bufA[MAX_PATH]:BYTE
  local buf[MAX_PATH]:TCHAR
  local	bytes:DWORD
  local bu[1]:BYTE
  local ch42:DWORD

;;SparseFileSupported
  invoke IsDlgButtonChecked,hWnd,id+42
  mov ch42,eax
  .if eax!=BST_UNCHECKED  ; = BST_INDETERMINATE or BST_CHECKED
    invoke GetVolumeInformation,
            0,
            0,
            MAX_PATH,
            0,
            0,
            addr bytes,
            0,
            MAX_PATH
    mov eax,bytes
    and eax,FILE_SUPPORTS_SPARSE_FILES
    .if eax==0
      invoke BeepIf,hWnd,beep_lo,beep_ms
      ret
    .endif
  .endif

  invoke QueryPerformanceCounter,addr L_I3
  invoke GetTickCount
  mov tm3,eax

  invoke SetTimer,hWnd,3,400,0
  invoke SetDlgItemInt,hWnd,id+60,0,0

  invoke GetDlgItemText,hWnd,id+24,addr buf,MAX_PATH-1
  .if eax==0
    invoke LoadString,hinst,60,addr buf,MAX_PATH-1
  .endif

  invoke CreateFile,
          addr buf,
          GENERIC_READ or GENERIC_WRITE,
          FILE_SHARE_READ or FILE_SHARE_WRITE,
          0,
          dwCreationDisposition,
          FILE_ATTRIBUTE_NORMAL,
          0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    .if ch42!=BST_UNCHECKED
;;SetSparse
      invoke DeviceIoControl,
              ebx,
              FSCTL_SET_SPARSE,
              0,
              0,
              0,
              0,
              addr bytes,
              0
    .endif

    invoke GetDlgItemTextA,hWnd,id+27,addr bufA,MAX_PATH-1
    .if eax!=0
      invoke htodw,addr bufA
    .endif
    mov esi,eax  ; hi-
    invoke GetDlgItemTextA,hWnd,id+28,addr bufA,MAX_PATH-1
    .if eax!=0
      invoke htodw,addr bufA
    .endif
    mov edi,eax  ; lo-

    .if ch42==BST_CHECKED
;;SetZeroData
;;SetSparseRange
      invoke RtlZeroMemory,addr fzdi,sizeof fzdi
      mov fzdi.FileOffset.HighPart,0
      mov fzdi.FileOffset.LowPart,0
      mov fzdi.BeyondFinalZero.HighPart,esi
      mov fzdi.BeyondFinalZero.LowPart,edi
      invoke DeviceIoControl,
              ebx,
              FSCTL_SET_ZERO_DATA,
              addr fzdi,
              sizeof fzdi,
              NULL,
              0,
              addr bytes,
              NULL
    .endif

    invoke SetFilePointerEx,ebx,
                            0,
                            0,
                            0,
                            FILE_BEGIN
    invoke GetDlgItemTextA,hWnd,id+26,addr bufA,MAX_PATH-1
    .if eax!=0
      invoke htodw,addr bufA
      mov byte ptr[bu],al
      mov bytes,1
      invoke WriteFile,ebx,
                       addr bu,
                       bytes,
                       addr bytes,
                       0
    .endif
    invoke SetFilePointerEx,ebx,
                            edi,
                            esi,
                            0,
                            FILE_BEGIN
    invoke SetEndOfFile,ebx
    invoke GetDlgItemTextA,hWnd,id+25,addr bufA,MAX_PATH-1
    .if eax!=0
      invoke SetFilePointerEx,ebx,
                              0ffffffffh, ; -1
                              0ffffffffh, ; -1
                              0,
                              FILE_END
      invoke htodw,addr bufA
      mov byte ptr[bu],al
      mov bytes,1
      invoke WriteFile,ebx,
                       addr bu,
                       bytes,
                       addr bytes,
                       0
    .endif
    invoke SetEndOfFile,ebx

    invoke GetFileSizeEx,ebx,addr li
    fn wsprintf,addr buf,"%8.8lX",li.LowPart
    invoke SetDlgItemText,hWnd,id+28,addr buf
    fn wsprintf,addr buf,"%8.8lX",li.HighPart
    invoke SetDlgItemText,hWnd,id+27,addr buf

    invoke CloseHandle,ebx
    mov ebx,beep_hi
  .else
    mov ebx,beep_lo
  .endif

  invoke KillTimer,hWnd,3

  invoke QueryPerformanceCounter,addr li
  invoke GetTickCount
  sub eax,tm3
  invoke SetDlgItemInt,hWnd,id+60,eax,0
  mov esi,L_I3.HighPart
  mov edi,L_I3.LowPart
  mov ecx,li.HighPart
  mov edx,li.LowPart
  sub edx,edi
  jnc @f
  dec ecx
@@:
  sub ecx,esi
;  fn wsprintf,addr buf,"%lX%8.8lX",ecx,edx
;  invoke SetDlgItemText,hWnd,id+60,addr buf

  invoke CloseHandle,hThread3
  .if eax!=0
    xor eax,eax
    mov hThread3,eax
    invoke BeepIf,hWnd,ebx,beep_ms
  .else
    fn MessageBox,0,"Fail",0,MB_SYSTEMMODAL or MB_ICONERROR
  .endif
  ret
ThreadMakeFile endp

;===================================================================

Proc0 proc uses ebx edi esi hWnd:HWND ; beep

  local li1:LARGE_INTEGER_
  local li2:LARGE_INTEGER_
  local hFile1:HANDLE
  local hFile2:HANDLE
  local err:DWORD
  local bytes:DWORD
  local bu[1]:BYTE
  local buf[MAX_PATH]:TCHAR
  local bufA[MAX_PATH]:BYTE

  xor eax,eax
  mov err,eax
  inc eax
  mov bytes,eax

  invoke RtlZeroMemory,addr li1,sizeof li1
  invoke RtlZeroMemory,addr li2,sizeof li2

  xor esi,esi
  xor edi,edi
  fn wsprintf,addr buf,"%8.8lX",edi
  invoke SetDlgItemText,hWnd,id+7,addr buf
  invoke SetDlgItemText,hWnd,id+8,addr buf

  invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1

  invoke CreateFile,addr buf,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_NORMAL, ;;  or FILE_FLAG_NO_BUFFERING,
                    0
  .if eax==INVALID_HANDLE_VALUE
    mov err,5
    jmp @1
  .else
    mov hFile1,eax

    invoke GetDlgItemText,hWnd,id+20,addr buf,MAX_PATH-1

    invoke CreateFile,addr buf,
                      GENERIC_READ,
                      FILE_SHARE_READ,
                      0,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      0
    .if eax==INVALID_HANDLE_VALUE
      mov err,5
      jmp @2
    .else
      mov hFile2,eax
;;
      .while TRUE
        invoke SetFilePointerEx,hFile1,
                                0,
                                0,
                                addr li1,
                                FILE_CURRENT
        .if eax==0
          mov err,19
          jmp @3
        .else
          invoke SetFilePointerEx,hFile2,
                                  0,
                                  0,
                                  addr li2,
                                  FILE_CURRENT
          .if eax==0
            mov err,19
            jmp @3
          .else
            mov esi,li2.HighPart
            mov edi,li2.LowPart
;;
            .if ch39==BST_CHECKED
              fn wsprintf,addr buf,"%8.8lX",esi
              invoke SetDlgItemText,hWnd,id+7,addr buf
              fn wsprintf,addr buf,"%8.8lX",edi
              invoke SetDlgItemText,hWnd,id+8,addr buf
            .endif
;;
      .break .if edi==L_I.LowPart && esi==L_I.HighPart
            invoke ReadFile,hFile1,
                            addr bu,
                            bytes,
                            addr bytes,
                            0
            .if eax==0
              mov err,20
              jmp @3
            .else
              xor eax,eax
              mov al,byte ptr[bu]
              push eax          
              invoke ReadFile,hFile2,
                              addr bu,
                              bytes,
                              addr bytes,
                              0
              pop edx
              .if eax==0
                mov err,20
                jmp @3
              .else
                xor eax,eax
                mov al,byte ptr[bu]
                .if al!=dl
                  push eax
                  fn wsprintf,addr buf,"%2.2lX",edx
                  invoke SetDlgItemText,hWnd,id+5,addr buf
                  pop eax
                  fn wsprintf,addr buf,"%2.2lX",eax
                  invoke SetDlgItemText,hWnd,id+6,addr buf
                  mov err,12
      .break
                .endif
              .endif
            .endif
          .endif
        .endif
      .endw
      
      .if err!=12                                             ; "!= NotEqual"
        mov err,11                                            ; "== Equal"
      .endif

      .if ch39==BST_UNCHECKED
        fn wsprintf,addr buf,"%8.8lX",esi
        invoke SetDlgItemText,hWnd,id+7,addr buf
        fn wsprintf,addr buf,"%8.8lX",edi
        invoke SetDlgItemText,hWnd,id+8,addr buf   
      .endif
@3:
      invoke CloseHandle,hFile2
    .endif
@2:
    invoke CloseHandle,hFile1  
  .endif
@1:
  mov eax,err
  ret
Proc0 endp

;===================================================================

; SECURITY_ATTRIBUTES STRUCT
;   nLength               DWORD ?
;   lpSecurityDescriptor  DWORD ?
;   bInheritHandle        DWORD ?
; SECURITY_ATTRIBUTES ENDS

Proc1 proc uses ebx edi esi hWnd:HWND

  local li1:LARGE_INTEGER_
  local li2:LARGE_INTEGER_
  local hFile1:HANDLE
  local hFile2:HANDLE
  local hMapFile1:HANDLE
  local hMapFile2:HANDLE  
  local lpMem1:DWORD
  local lpMem2:DWORD
  local var:DWORD
  local cntr:DWORD
  local gran:DWORD
  local bytes:DWORD
  local err:DWORD  
  local bu[1]:BYTE
  local bufA[MAX_PATH]:BYTE
  local buf[MAX_PATH]:TCHAR
  local s_a:SECURITY_ATTRIBUTES

  invoke GetDlgItemTextA,hWnd,id+29,addr bufA,MAX_PATH-1
  invoke htodw,addr bufA
  mov gran,eax

  xor eax,eax
  mov var,eax
  mov cntr,eax
  mov err,eax
  mov lpMem1,eax
  mov lpMem2,eax
  inc eax
  mov bytes,eax

  invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1

  invoke CreateFile,addr buf,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,               ;;  addr SECURITY_ATTRIBUTES
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_READONLY or FILE_FLAG_SEQUENTIAL_SCAN,
                    0
  .if eax==INVALID_HANDLE_VALUE
    mov err,5
    jmp @err
  .else
    mov hFile1,eax
  .endif

  invoke GetDlgItemText,hWnd,id+20,addr buf,MAX_PATH-1

  invoke CreateFile,addr buf,
                    GENERIC_READ,
                    FILE_SHARE_READ,
                    0,
                    OPEN_EXISTING,
                    FILE_ATTRIBUTE_READONLY or FILE_FLAG_SEQUENTIAL_SCAN,
                    0 
  .if eax==INVALID_HANDLE_VALUE
    mov err,5
    jmp @err
  .else
    mov hFile2,eax
  .endif

  invoke CreateFileMapping,hFile1,
                           0,
                           PAGE_READONLY,
                           0,                   ; dwMaximumSizeHigh ; L_I.HighPart
                           0,                   ; dwMaximumSizeLow  ; L_I.LowPart
                           0                    ; lpName
  .if eax==0
    mov err,17
    jmp @err
  .else
    mov hMapFile1,eax
  .endif

  invoke CreateFileMapping,hFile2,
                           0,
                           PAGE_READONLY,  ; PAGE_READWRITE , PAGE_READ
                           0,
                           0,
                           0
  .if eax==0
    mov err,17
    jmp @err
  .else
    mov hMapFile2,eax
  .endif

  .if err==0

    xor ebx,ebx
    xor edi,edi
    mov L_I1.HighPart,edi
    mov L_I1.LowPart,edi
    fn wsprintf,addr buf,"%8.8lX",edi
    invoke SetDlgItemText,hWnd,id+7,addr buf
    invoke SetDlgItemText,hWnd,id+8,addr buf

    .while TRUE
        
      mov edx,edi
      mov ecx,ebx
      mov eax,L_I.LowPart
      sub eax,ebx
      add ecx,eax
      jnc @f
      inc edx
@@:
      .if edx==L_I.HighPart && eax<=gran
        mov gran,eax
        inc var
      .endif

      invoke MapViewOfFileEx,hMapFile1,
                             FILE_MAP_READ,         ; dwDesiredAccess
                             edi,                   ; dwFileOffsetHigh
                             ebx,                   ; dwFileOffsetLow
                             gran,                  ; dwNumberOfBytesToMap
                             0 ;; lpMem1            ; lpBaseAddress
      .if eax==0
        mov err,16
        jmp @err
      .else
        mov lpMem1,eax
      .endif

      invoke MapViewOfFileEx,hMapFile2,
                             FILE_MAP_READ,
                             edi,
                             ebx,
                             gran,
                             0 ;; lpMem2
      .if eax==0
        mov err,16
        jmp @err
      .else
        mov lpMem2,eax
      .endif

    .break .if err!=0

      invoke RtlCompareMemory,lpMem1,lpMem2,gran

      .if eax!=gran
        mov err,12
      .endif
      push eax

;      invoke FlushViewOfFile,lpMem1,0
;      invoke FlushFileBuffers,hFile1

      invoke UnmapViewOfFile,lpMem1
      .if eax==0
        pop eax
        mov err,22                                ; "-- UnmapViewOfFile error"
        jmp @err
      .endif

;      invoke FlushViewOfFile,lpMem2,0
;      invoke FlushFileBuffers,hFile2      

      invoke UnmapViewOfFile,lpMem2
      .if eax==0
        pop eax
        mov err,22                                ; "-- UnmapViewOfFile error"
        jmp @err
      .endif

      pop eax
      .if err!=0 || var!=0
        add ebx,eax
    .break
      .endif
      add ebx,gran
      jnc @f
      inc edi
@@:
      inc cntr
      .if ch39==BST_CHECKED
        mov L_I1.HighPart,edi
        fn wsprintf,addr buf,"%8.8lX",edi
        invoke SetDlgItemText,hWnd,id+7,addr buf
        mov L_I1.LowPart,ebx
        fn wsprintf,addr buf,"%8.8lX",ebx
        invoke SetDlgItemText,hWnd,id+8,addr buf
        invoke SetDlgItemInt,hWnd,id+15,cntr,0
      .endif
    .endw
  .endif

  mov L_I1.HighPart,edi  
  fn wsprintf,addr buf,"%8.8lX",edi
  invoke SetDlgItemText,hWnd,id+7,addr buf

  mov L_I1.LowPart,ebx
  fn wsprintf,addr buf,"%8.8lX",ebx
  invoke SetDlgItemText,hWnd,id+8,addr buf

  .if err!=0
    invoke SetFilePointerEx,hFile1,
                            ebx,
                            edi,
                            0,
                            FILE_CURRENT
    invoke ReadFile,hFile1,
                    addr bu,
                    bytes,
                    addr bytes,
                    0
    xor eax,eax
    mov al,byte ptr[bu]
    fn wsprintf,addr buf,"%2.2lX",eax
    invoke SetDlgItemText,hWnd,id+5,addr buf

    invoke SetFilePointerEx,hFile2,
                            ebx,
                            edi,
                            0,
                            FILE_CURRENT    
    invoke ReadFile,hFile2,
                    addr bu,
                    bytes,
                    addr bytes,
                    0
    xor eax,eax
    mov al,byte ptr[bu]
    fn wsprintf,addr buf,"%2.2lX",eax
    invoke SetDlgItemText,hWnd,id+6,addr buf
  .endif

@err:
  xor ebx,ebx
  .if hFile1!=ebx
    invoke CloseHandle,hFile1
    mov hFile1,ebx
  .endif
  .if hFile2!=ebx
    invoke CloseHandle,hFile2
    mov hFile2,ebx
  .endif
  .if hMapFile1!=ebx
    invoke CloseHandle,hMapFile1
    mov hMapFile1,ebx
  .endif
  .if hMapFile2!=ebx
    invoke CloseHandle,hMapFile2
    mov hMapFile2,ebx
  .endif

  mov eax,err
  .if eax==ebx
    mov eax,11                                    ; "== Equal"
  .endif
  ret
Proc1 endp

;===================================================================

CreateProc proc uses ebx edi esi lpbuff:DWORD,flags:DWORD,waitf:DWORD  ; flags = NORMAL_PRIORITY_CLASS/CREATE_NO_WINDOW  ; waitf = INFINITE/N(ms)/0

  local p_i:PROCESS_INFORMATION
  local sui:STARTUPINFO
  local lpExitCode:DWORD
  local buf[MAX_PATH]:TCHAR

  xor esi,esi
  mov lpExitCode,esi

  invoke RtlZeroMemory,addr p_i,sizeof p_i
  invoke RtlZeroMemory,addr sui,sizeof sui

  invoke CreateProcess,0,
                       lpbuff,
                       0,
                       0,
                       0,
                       flags,
                       0,
                       0,
                       addr sui,
                       addr p_i
  test eax,eax
  jz @f
  mov ebx,eax
  mov eax,p_i.dwThreadId
  mov tid,eax
  invoke WaitForSingleObject,p_i.hProcess,waitf
  mov esi,eax
  invoke GetExitCodeProcess,p_i.hProcess,addr lpExitCode
  mov edx_,eax        ; 0 => fail
  invoke CloseHandle,p_i.hProcess
  invoke CloseHandle,p_i.hThread
  mov ecx,esi         ; WAIT_ABANDONED / WAIT_OBJECT_0 / WAIT_TIMEOUT /WAIT_FAILED
  mov edx,lpExitCode  ; STILL_ACTIVE
  mov eax,ebx
@@:                   ; eax==0 => fail
  ret
CreateProc endp

;===================================================================

ProcE proc uses ebx edi esi hWnd:HWND

  local buff[1024]:TCHAR
  local buf[MAX_PATH]:TCHAR
  local buf1[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR

  invoke SetDlgItemText,hWnd,id+15,0
  invoke GetDlgItemText,hWnd,id+29,addr buf,MAX_PATH-1  
  invoke GetDlgItemText,hWnd,id+10,addr buf1,MAX_PATH-1
  invoke GetDlgItemText,hWnd,id+20,addr buf2,MAX_PATH-1
  fn wsprintf,addr buff,addr buf,addr buf1,addr buf2
  invoke IsDlgButtonChecked,hWnd,id+40
  .if eax==BST_CHECKED
    mov edx,NORMAL_PRIORITY_CLASS
  .else
    mov edx,CREATE_NO_WINDOW
  .endif
  invoke CreateProc,addr buff,edx,INFINITE
  mov ebx,eax

  mov edi,edx
  invoke SetDlgItemInt,hWnd,id+15,edx,1
  mov edx,edi
  mov eax,ebx
  ret
ProcE endp

;===================================================================

KillTimerProc proc uses ebx edi esi hWnd:HWND

  local li:LARGE_INTEGER_
  local buff[1024]:TCHAR
  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR
  local buf3[32]:TCHAR

  invoke KillTimer,hWnd,2

  invoke QueryPerformanceCounter,addr li
  invoke GetTickCount
  sub eax,tm2
  mov tm2,eax

  invoke LoadString,hinst,28,addr buf2,MAX_PATH-1
  invoke GetDlgItemText,hWnd,id+3,addr buf3,32

  invoke GetDlgItemText,hWnd,id+29,addr buf,MAX_PATH-1

  mov esi,L_I2.HighPart
  mov edi,L_I2.LowPart
  mov ecx,li.HighPart
  mov edx,li.LowPart
  sub edx,edi
  jnc @f
  dec ecx
@@:
  sub ecx,esi
  invoke wsprintf,addr buff,addr buf2,procN,tm2,ecx,edx,L_I.HighPart,L_I.LowPart,addr buf,addr buf3

  invoke StringToLog,addr buff
  invoke SendDlgItemMessage,hWnd,id+61,CB_ADDSTRING,0,addr buff

  fn wsprintf,addr buf,"%d",tm2
  invoke SetDlgItemText,hWnd,id+61,addr buf

  ret
KillTimerProc endp

;===================================================================

ThreadProc proc uses ebx edi esi hWnd:HWND

  local li:LARGE_INTEGER_
  local buf[MAX_PATH]:TCHAR
  local buf1[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR
  local buf3[MAX_PATH]:TCHAR
  local buf4[MAX_PATH]:TCHAR

  invoke QueryPerformanceCounter,addr L_I2
  invoke GetTickCount
  mov tm2,eax

  invoke SetTimer,hWnd,2,400,0

  invoke SetDlgItemText,hWnd,id+2,0
  invoke SetDlgItemText,hWnd,id+3,0
  invoke SetDlgItemText,hWnd,id+15,0
  invoke SetDlgItemInt,hWnd,id+61,0,0

  inc tid
  mov ebx,procN
  .if ebx==0
    invoke Proc0,hWnd
  .elseif ebx==1
    invoke Proc1,hWnd
  .else ; if ebx>=2     ; (external app)
    invoke ProcE,hWnd
    .if eax==0
      mov eax,18        ; "-- Error"
    .else
      mov edi,edx
      add ebx,ebx
      add ebx,ebx
      add ebx,ii
      inc ebx
      inc ebx
      invoke LoadString,hinst,ebx,addr buf,MAX_PATH-1
      invoke StrToInt,addr buf
      mov esi,eax
      inc ebx
      invoke LoadString,hinst,ebx,addr buf,MAX_PATH-1
      invoke StrToInt,addr buf
      .if edi==esi
        mov eax,11      ; "== Equal"
      .elseif edi==eax
        mov eax,12      ; "!= NotEqual"
      .else
        mov eax,18  ; 7 ; "-- Error"  ; "-- Func error"
      .endif
    .endif
  .endif
  mov ebx,eax

  invoke LoadString,hinst,ebx,addr buf,MAX_PATH-1
  invoke SetDlgItemText,hWnd,id+2,addr buf
  lea edx,buf
  mov TCHAR ptr[edx+2*sizeof(TCHAR)],0
  invoke SetDlgItemText,hWnd,id+3,addr buf

  .if tid!=0
    invoke KillTimerProc,hWnd
  .endif

  .if ebx==11 || ebx==10
    mov edx,beep_hi
    mov edi,1
  .else
    mov edx,beep_lo
    mov edi,3
  .endif
  invoke BeepIf,hWnd,edx,beep_ms
  .if minim!=0
    .while edi>0
      invoke ShowWindow,hWnd,SW_HIDE ; SW_MINIMIZE
      invoke Sleep,100
      invoke ShowWindow,hWnd,SW_SHOWNORMAL ; SW_RESTORE
      invoke Sleep,100        
      dec edi
    .endw
  .endif
  invoke RedrawWindow,hWnd,0,0,RDW_UPDATENOW or RDW_INVALIDATE ; or RDW_ALLCHILDREN
  invoke CloseHandle,hThread2
  .if eax!=0
    xor eax,eax
    mov hThread2,eax
  .else
    fn MessageBox,0,"Fail",0,MB_SYSTEMMODAL or MB_ICONERROR
  .endif

  xor eax,eax
  mov tid,eax
  mov hThread2,eax
  mov flg,eax

  ret
ThreadProc endp

;===================================================================

SaveSettings proc uses ebx hWnd:HWND,lpFileName:DWORD

  local	bytes:DWORD
  local wi:WINDOWINFOEX

  invoke RtlZeroMemory,addr wi,sizeof wi
  mov wi.cbSize,sizeof wi
  invoke GetWindowInfo,hWnd,addr wi

  invoke IsDlgButtonChecked,hWnd,id+37
  mov wi.rcClient.left,eax

  invoke IsDlgButtonChecked,hWnd,id+39
  mov wi.rcClient.top,eax

  invoke IsDlgButtonChecked,hWnd,id+40
  mov wi.rcClient.right,eax

  invoke IsDlgButtonChecked,hWnd,id+32
  mov wi.rcClient.bottom,eax

  invoke IsDlgButtonChecked,hWnd,id+44
  mov wi.dwWindowStatus,eax

  mov eax,procN
  mov wi.atomWindowType,ax

  mov eax,dwCreationDisposition
  mov wi.wCreatorVersion,ax

  invoke GetDlgItemText,hWnd,id+10,addr wi.t1,MAX_PATH-1
  invoke GetDlgItemText,hWnd,id+20,addr wi.t2,MAX_PATH-1

  invoke CreateFile,lpFileName,\
                    GENERIC_READ or GENERIC_WRITE,\
                    FILE_SHARE_READ or FILE_SHARE_WRITE,\
                    0,\
                    CREATE_ALWAYS,\
                    FILE_ATTRIBUTE_NORMAL,\
                    0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointer,ebx,0,0,FILE_END
    mov bytes,sizeof wi
    invoke WriteFile,ebx,addr wi,bytes,addr bytes,0
    invoke CloseHandle,ebx
  .endif
  ret
SaveSettings endp

;===================================================================

RestoreSettings proc uses ebx edi hWnd:HWND,lpFileName:DWORD

  local bytes:DWORD
  local wi:WINDOWINFOEX

  invoke CreateFile,lpFileName,\
                    GENERIC_READ,\
                    FILE_SHARE_READ,\
                    0,\
                    OPEN_ALWAYS,\
                    FILE_ATTRIBUTE_NORMAL,\
                    0
  .if eax!=INVALID_HANDLE_VALUE
    mov	ebx,eax
    invoke GetFileSize,eax,0
    .if eax==sizeof WINDOWINFOEX
      mov bytes,eax

      invoke ReadFile,ebx,addr wi,bytes,addr bytes,0
      .if eax!=0

        mov edx,wi.rcWindow.bottom
        sub edx,wi.rcWindow.top
        mov eax,wi.rcWindow.right
        sub eax,wi.rcWindow.left
        invoke SetWindowPos,hWnd,HWND_TOPMOST,wi.rcWindow.left,wi.rcWindow.top,eax,edx,SWP_FRAMECHANGED

        invoke CheckDlgButton,hWnd,id+37,wi.rcClient.left
        mov eax,wi.rcClient.top
        mov ch39,eax        
        invoke CheckDlgButton,hWnd,id+39,eax
        invoke CheckDlgButton,hWnd,id+40,wi.rcClient.right
        invoke CheckDlgButton,hWnd,id+32,wi.rcClient.bottom
        invoke CheckDlgButton,hWnd,id+44,wi.dwWindowStatus

        xor eax,eax
        mov ax,wi.atomWindowType
        mov procN,eax

        xor eax,eax
        mov ax,wi.wCreatorVersion
        mov dwCreationDisposition,eax

        invoke SetDlgItemText,hWnd,id+10,addr wi.t1
        invoke SetDlgItemText,hWnd,id+70,addr wi.t1
        invoke SetDlgItemText,hWnd,id+20,addr wi.t2

      .endif
    .endif
    invoke CloseHandle,ebx
    invoke GetDlgItem,hWnd,id+20
    invoke SetWindowPos,eax,HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
  .endif
  ret
RestoreSettings endp
;===================================================================

ClearProc proc uses edi hWnd:HWND,param:DWORD

  local buf[MAX_PATH]:TCHAR

  xor edi,edi
  mov L_I1.HighPart,edi
  mov L_I1.LowPart,edi
  invoke SetDlgItemText,hWnd,id+60,edi
  invoke SetDlgItemText,hWnd,id+61,edi

  mov edi,id+1
  .while edi<=id+28
    .if edi==id+13 || edi==id+4 || (param!=0 && (edi==id+10 || edi==id+20))
      jmp @f
    .endif
    invoke SetDlgItemText,hWnd,edi,0
@@:
    inc edi
  .endw

  ret
ClearProc endp

;===================================================================

SetCaption proc uses ebx edi esi hWnd:HWND

  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR
  local buf3[MAX_PATH]:TCHAR
  local rt:RECT

  invoke GetDlgItem,hWnd,id+20
  mov edx,eax
  invoke GetWindowRect,edx,addr rt
  mov ebx,rt.top
  sub ebx,4
  invoke GetDlgItem,hWnd,id+10
  mov edi,eax
  invoke GetWindowRect,edi,addr rt
  invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1
  .if eax==0 || ebx>=rt.top
    invoke LoadString,hinst,2,addr buf2,MAX_PATH-1
    mov edx,procN
    add edx,edx
    add edx,edx
    add edx,ii
    invoke LoadString,hinst,edx,addr buf3,MAX_PATH-1
    invoke wsprintf,addr buf,addr buf2,procN,addr buf3
  .endif
  invoke SetWindowText,hWnd,addr buf
  ret
SetCaption endp

;===================================================================

OnSize proc uses ebx edi esi hWnd:HWND,lParam:LPARAM

  local rt:RECT
  local det:DWORD

  mov edi,lParam
  mov esi,edi
  and edi,0FFFFh
  shr esi,16
  invoke GetDlgItem,hWnd,id+10
  mov ebx,eax
  invoke GetWindowRect,ebx,addr rt
  invoke MapWindowPoints,0,hWnd,addr rt,2
  mov eax,rt.left
  mov det,eax
  sub edi,det
  sub edi,det
  push ebx
  invoke GetDlgItem,hWnd,id+20
  mov ebx,eax
  invoke GetSystemMetrics,SM_CYSMCAPTION
  add eax,esi
  shr eax,1  
  mov edx,esi
  sub edx,eax  ; rt.top2 = rt.bottom1
  push edx
  sub eax,det
  invoke SetWindowPos,ebx,HWND_TOP,det,edx,edi,eax,SWP_FRAMECHANGED
  pop edx
  sub edx,rt.top
  pop ebx  
  invoke SetWindowPos,ebx,0,0,0,edi,edx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
  push 0
  push id+61
  push id+29
  push id+4
  .while TRUE
    pop eax
  .break .if eax==0
    invoke GetDlgItem,hWnd,eax
    mov ebx,eax
    invoke GetWindowRect,ebx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    mov ecx,rt.bottom
    sub ecx,rt.top
    mov edx,edi
    sub edx,rt.left
    add edx,det
    invoke SetWindowPos,ebx,0,0,0,edx,ecx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
  .endw
  ret
OnSize endp

;===================================================================

SubClass2 proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg==WM_ENTERIDLE
    invoke GetAncestor,hWnd,GA_ROOT
    invoke PostMessage,eax,uMsg,wParam,lParam
  .else
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
SubClass2 endp

;===================================================================

SubClass proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg==WM_LBUTTONDOWN || uMsg==WM_LBUTTONDBLCLK || uMsg==WM_ENTERIDLE
    invoke GetDlgCtrlID,hWnd
    .if eax==id+10 || eax==id+20
      invoke SetFocus,hWnd
    .endif
    invoke GetAncestor,hWnd,GA_ROOT
    invoke PostMessage,eax,uMsg,wParam,lParam
    .if uMsg==WM_LBUTTONDBLCLK                  ; (for SS_NOTIFY + manifest)
      jmp @f
    .endif
  .else
@@:
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
SubClass endp

;===================================================================

CHANGEFILTERSTRUCT struct
  cbSize      DWORD ?
  ExtStatus   DWORD ?
CHANGEFILTERSTRUCT ends

DragDropUAC proc uses ebx edi esi hWnd:HWND,param:DWORD

  local cfs:CHANGEFILTERSTRUCT

  invoke RtlZeroMemory,addr cfs,sizeof cfs
  mov cfs.cbSize,sizeof cfs  
  lea esi,cfs
.data
  _cwmfx db "ChangeWindowMessageFilterEx",0
  _cwmf  db "ChangeWindowMessageFilter",0
.code
  .if param!=0
    mov edi,MSGFLT_ALLOW
  .else
    mov edi,MSGFLT_DISALLOW  ; MSGFLT_RESET 
  .endif
;  invoke ChangeWindowMessageFilterEx,hWnd,WM_DROPFILES,edi,addr cfs
;  invoke ChangeWindowMessageFilterEx,hWnd,WM_COPYGLOBALDATA,edi,addr cfs
  fn GetModuleHandle,"user32.dll"
  invoke GetProcAddress,eax,offset _cwmfx
  .if eax!=0
    mov ebx,eax
    push esi
    push edi
    push WM_DROPFILES
    push hWnd
    call ebx
    push esi
    push edi
    push WM_COPYGLOBALDATA
    push hWnd
    call ebx
  .endif

;  .if param!=0
;    mov edi,MSGFLT_ADD
;  .else
;    mov edi,MSGFLT_REMOVE
;  .endif  
;;  invoke ChangeWindowMessageFilter,WM_DROPFILES,ebx
;;  invoke ChangeWindowMessageFilter,WM_COPYGLOBALDATA,ebx
;  fn GetModuleHandle,"user32.dll"
;  invoke GetProcAddress,eax,offset _cwmf
;  .if eax!=0
;    mov ebx,eax
;    push edi
;    push WM_DROPFILES
;    call ebx
;    push edi
;    push WM_COPYGLOBALDATA
;    call ebx
;  .endif

  ret
DragDropUAC endp

;===================================================================

OnSetCursor proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local wfd:WIN32_FIND_DATA
  local li:LARGE_INTEGER_
  local pt:POINT
  local var:DWORD
  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR
  local buf3[MAX_PATH]:TCHAR

  invoke GetCursorPos,addr pt
  mov eax,pt.x
  mov esi,pt.y
  shl esi,16
  and eax,0ffffh
  or esi,eax

  push pt.x
  push pt.y
  invoke MapWindowPoints,0,hWnd,addr pt,1
  invoke ChildWindowFromPointEx,hWnd,pt.x,pt.y,CWP_SKIPINVISIBLE
  pop pt.y
  pop pt.x

  invoke GetDlgCtrlID,eax ; wParam
  mov edi,eax

  mov ebx,lParam
  mov edx,ebx
  shr edx,16

  .if dx==WM_LBUTTONDOWN

    .if edi==id+3
      invoke GetWindowLong,hWnd,GWL_EXSTYLE
      mov edx,eax
      mov ecx,WS_EX_TOPMOST
      and edx,ecx
      .if edx==0
        or eax,ecx
        push HWND_TOPMOST
      .else
        xor eax,ecx
        push HWND_NOTOPMOST
      .endif
      invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
      pop eax
      invoke SetWindowPos,hWnd,eax,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    .endif

  .elseif dx==WM_RBUTTONUP

    .if edi==id+3
      invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_HIDEWINDOW
      invoke GetWindowLong,hWnd,GWL_EXSTYLE
      xor eax,WS_EX_TOOLWINDOW
      invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
      invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_SHOWWINDOW

    .elseif bx!=HTCLIENT && bx!=HTCAPTION && bx!=HTCLOSE
      invoke GetSystemMenu,hWnd,0
      invoke TrackPopupMenuEx,eax,0,pt.x,pt.y,hWnd,0

    .elseif bx==HTCLOSE                                      ; Rerun
      invoke GetStringFileName,61,addr buf
      invoke SaveSettings,hWnd,addr buf
      invoke GetModuleFileName,0,addr buf,MAX_PATH-1
;      invoke ShellExecute,0,0,addr buf,0,0,SW_SHOWNORMAL
      invoke CreateProc,addr buf,NORMAL_PRIORITY_CLASS,40
      invoke DeleteObject,hbrush
      invoke EndDialog,hWnd,0

    .endif
    xor eax,eax
    jmp @ret

  .elseif dx==WM_RBUTTONDOWN

    .if edi==id+44                                         
      invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1 
      invoke GetDlgItemText,hWnd,id+70,addr buf2,MAX_PATH-1
      invoke MoveFile,addr buf2,addr buf                   
      invoke SetDlgItemText,hWnd,id+70,addr buf            

    .elseif edi==id+33
      invoke GetModuleFileName,0,addr buf,MAX_PATH-1
      invoke PathRemoveFileSpec,addr buf
      fn wsprintf,addr buf2,"explorer.exe %s",addr buf
      invoke CreateProc,addr buf2,NORMAL_PRIORITY_CLASS,0

    .elseif edi==id+34
      .if hThread3==0
        invoke BeepIf,hWnd,beep_hi,beep_ms
        mov esi,dwCreationDisposition
        inc esi
        .if esi==6
          mov esi,1
        .endif
        mov dwCreationDisposition,esi
        add esi,30
        invoke LoadString,hinst,esi,addr buf,MAX_PATH-1
        invoke SetDlgItemText,hWnd,id+4,addr buf
      .else
        invoke BeepIf,hWnd,beep_lo,beep_ms
      .endif

    .elseif edi==id+31  ; CLEAR
      xor ebx,ebx
      inc ebx
      jmp @f
    .elseif edi==id+36  ; ERASE
      invoke SetDlgItemText,hWnd,id+70,0
      xor ebx,ebx
@@:
      .if hThread3==0 && hThread2==0
        invoke ClearProc,hWnd,ebx
      .else
        invoke BeepThreadIf,hWnd,beep_lo
      .endif

    .endif
    xor eax,eax
    jmp @ret

  .elseif bx==HTCAPTION || (bx>=10 && bx<=17)  ;; 10<= HT* <=17
    mov esi,65

  .elseif bx==HTCLOSE
    mov esi,64

  .else
    mov esi,edi
    mov ecx,procN
    .if edi==id+29
      .if ecx==0
        mov esi,24
      .elseif ecx==1
        mov esi,25
      .endif
    .elseif edi==id+15
      .if ecx==0
        mov esi,24
      .elseif ecx==1
        mov esi,26
      .endif
    .elseif edi==id+34
      mov esi,dwCreationDisposition
      add esi,30
    .elseif edi==1001
      invoke GetParent,wParam
      invoke GetDlgCtrlID,eax
      mov esi,eax
    .endif
  .endif

  invoke SetDlgItemInt,hWnd,id+13,edi,1
  lea ebx,buf
  invoke LoadString,hinst,esi,ebx,MAX_PATH-1
  .if esi==25
    invoke GetAllocGran
    fn wsprintf,addr buf2,ebx,eax
    lea ebx,buf2
  .elseif esi==id+3
    invoke GetDlgItemText,hWnd,id+2,addr buf3,MAX_PATH-1
    .if eax==0
      fn lstrcpy,addr buf3,"result"
    .endif
    fn wsprintf,addr buf2,ebx,addr buf3
    lea ebx,buf2
  .endif
  invoke SetDlgItemText,hWnd,id+4,ebx

  .if edi==id+24
    mov esi,6
    jmp @f
  .elseif edi==id+15
    mov esi,8
@@:
    invoke GetDlgItemText,hWnd,edi,addr buf,MAX_PATH-1
    .if eax>esi
      invoke SetWindowText,hWnd,addr buf
    .endif
  .elseif edi==id+11 || edi==id+12
    mov esi,id+10
    jmp @f
  .elseif edi==id+21 || edi==id+22
    mov esi,id+20
    jmp @f
  .elseif edi==id+27 || edi==id+28
    mov esi,id+24
@@:
    invoke GetDlgItemText,hWnd,esi,addr buf,MAX_PATH-1
    .if eax!=0 && hThread2==0 && hThread3==0
      invoke FindFirstFile,addr buf,addr wfd
      .if eax!=INVALID_HANDLE_VALUE && eax!=0
        push eax
        xor eax,eax
        mov var,eax
        invoke LoadString,hinst,3,addr buf2,MAX_PATH-1
        invoke GetCompressedFileSize,addr buf,addr var
        mov esi,eax
        invoke RtlZeroMemory,addr li,sizeof li
        invoke FileSizeEx,addr buf,addr li
        mov edx,var
        .if esi!=li.LowPart || edx!=li.HighPart
          fn wsprintf,addr buf,addr buf2,var,esi
          invoke SetWindowText,hWnd,addr buf
        .endif
        call FindClose
      .endif
    .endif
  .else
    invoke SetCaption,hWnd
  .endif
  xor eax,eax

@ret:
  ret
OnSetCursor endp

;===================================================================

EnumThreadWndProc proc uses ebx edi esi hWnd:HWND,lParam:LPARAM

  local buf[MAX_PATH]:TCHAR

  invoke GetClassName,hWnd,addr buf,MAX_PATH-1
  fn lstrcmpi,addr buf,"#32770"
  .if eax==0
    invoke GetWindowText,hWnd,addr buf,9  ;
    fn lstrcmp,addr buf,"ExamDiff"        ;;
    .if eax==0                            ;
      inc flg                             ;flg
      jmp @ret                            ;
    .endif                                ;
    jmp @f
  .endif
  fn lstrcmpi,addr buf,"WinDiffViewerClass"
  .if eax==0
    invoke GetWindowText,hWnd,addr buf,MAX_PATH-1
    fn lstrcmpi,addr buf,"WinDiff"
    .if eax==0
@@:
      invoke KillTimerProc,lParam
      xor eax,eax
      mov tid,eax
      jmp @ret
    .endif
  .endif
  xor eax,eax
  inc eax
@ret:
  ret
EnumThreadWndProc endp

;===================================================================

OnTimer proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local cbi:COMBOBOXINFO_
  local li:LARGE_INTEGER_
  local pt:POINT
  local rt:RECT
  local var:DWORD
  local buf[MAX_PATH]:TCHAR

  .if wParam==2

    mov ebx,id+61
    mov eax,tm2
    mov var,eax
    mov edi,L_I2.LowPart
    mov esi,L_I2.HighPart
;   .if tid!=0 && flg==0
    .if tid!=0 && (procN==5 || procN==14)  ; (WinDiff || FileIdent)
      invoke EnumThreadWindows,tid,offset EnumThreadWndProc,hWnd
    .endif
    jmp @f

  .elseif wParam==3

    mov ebx,id+60
    mov eax,tm3
    mov var,eax
    mov edi,L_I3.LowPart
    mov esi,L_I3.HighPart
@@:
    invoke GetTickCount
    sub eax,var
    invoke SetDlgItemInt,hWnd,ebx,eax,0

    invoke QueryPerformanceCounter,addr li
    mov ecx,li.HighPart
    mov edx,li.LowPart
    sub edx,edi
    jnc @f
    dec ecx
@@:
    sub ecx,esi
;    fn wsprintf,addr buf,"%lX%8.8lX",ecx,edx
;    invoke SetDlgItemText,hWnd,ebx,addr buf

    xor trig,1
    lea edx,buf
    .if trig==0
      mov TCHAR ptr[edx],['/']
    .else
      mov TCHAR ptr[edx],['\']
    .endif
    mov TCHAR ptr[edx+sizeof(TCHAR)],0    
    invoke SetDlgItemText,hWnd,id+3,addr buf

  .elseif wParam==4  ; LR-click
  
    invoke GetAsyncKeyState,VK_LBUTTON
    mov ebx,eax
    and ebx,8000h
    invoke GetAsyncKeyState,VK_RBUTTON
    and eax,8000h
    .if eax!=0 && ebx!=0
      invoke GetCursorPos,addr pt
      invoke GetWindowRect,hWnd,addr rt
      invoke PtInRect,addr rt,pt.x,pt.y
      .if eax!=0
        invoke KillTimer,hWnd,4
        invoke GetWindowLong,hWnd,GWL_EXSTYLE
        and eax,not WS_EX_TRANSPARENT
        and eax,not WS_EX_LAYERED
        invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
        invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
        mov edi,id+60
        .while edi<=id+61
          invoke RtlZeroMemory,addr cbi,sizeof cbi
          mov cbi.cbSize,sizeof cbi
          invoke GetDlgItem,hWnd,edi
          mov edx,eax
          invoke GetComboBoxInfo,edx,addr cbi
          invoke GetWindowLong,cbi.hwndList,GWL_EXSTYLE
          and eax,not WS_EX_LAYERED
          and eax,not WS_EX_TRANSPARENT
          invoke SetWindowLong,cbi.hwndList,GWL_EXSTYLE,eax
          invoke SetWindowPos,cbi.hwndList,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
          inc edi
        .endw
        invoke GetSystemMenu,hWnd,0
        mov ebx,eax
        invoke CheckMenuItem,ebx,0e070h,MF_UNCHECKED
        invoke CheckMenuItem,ebx,0e080h,MF_UNCHECKED
      .endif
    .endif
    
  .else
    xor eax,eax
    jmp @f
    
  .endif
  xor eax,eax
  inc eax
@@:
  ret
OnTimer endp

;===================================================================

OnCommand proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR
  local bufA[MAX_PATH]:BYTE

  .if wParam==id+34  ; "+"
    .if hThread3==0
	    invoke BeepIf,hWnd,beep_hi,beep_ms
      invoke CreateThread,0,0,offset ThreadMakeFile,hWnd,0,0
      mov hThread3,eax
    .else
      invoke BeepThreadIf,hWnd,beep_lo
    .endif

  .elseif wParam==id+33  ; "D"
    invoke GetModuleFileName,0,addr buf,MAX_PATH-1
    invoke PathRemoveFileSpec,addr buf
    invoke ShellExecute,0,0,addr buf,0,0,SW_SHOWNORMAL

  .elseif (wParam==10000h*CBN_SELENDOK + id+60)
    .if hThread2==0
      invoke SendDlgItemMessage,hWnd,id+60,CB_GETCURSEL,0,0
      mov procN,eax
      mov edi,eax
      .if edi==1
        .if granul==0
          invoke GetAllocGran
        .else
          mov eax,granul
        .endif
        fn wsprintf,addr buf,"%8.8lX",eax
      .else
        add edi,edi
        add edi,edi
        add edi,ii
        inc edi
        invoke LoadString,hinst,edi,addr buf,MAX_PATH-1
      .endif    
      invoke SetDlgItemText,hWnd,id+29,addr buf
      invoke SetCaption,hWnd
    .else
      invoke BeepThreadIf,hWnd,beep_lo
    .endif

  .elseif wParam==(id+29 + 10000h*EN_UPDATE) && (procN==1)
    invoke GetFocus
    .if eax==lParam
      invoke GetDlgItemTextA,hWnd,id+29,addr bufA,MAX_PATH-1
      invoke htodw,addr bufA
      mov granul,eax
      invoke BeepThreadIf,hWnd,beep_hi
    .endif

  .elseif wParam==id+36  ; (swap %1 <--> %2)
    .if hThread2!=0 || hThread3!=0
      invoke BeepThreadIf,hWnd,beep_lo
    .else
      invoke BeepIf,hWnd,beep_hi,beep_ms

      invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1
      invoke GetDlgItemText,hWnd,id+20,addr buf2,MAX_PATH-1
      invoke SetDlgItemText,hWnd,id+10,addr buf2
      invoke SetDlgItemText,hWnd,id+70,addr buf2
      invoke SetDlgItemText,hWnd,id+20,addr buf

      invoke GetDlgItemText,hWnd,id+11,addr buf,MAX_PATH-1
      invoke GetDlgItemText,hWnd,id+21,addr buf2,MAX_PATH-1
      invoke SetDlgItemText,hWnd,id+11,addr buf2
      invoke SetDlgItemText,hWnd,id+21,addr buf

      invoke GetDlgItemText,hWnd,id+12,addr buf,MAX_PATH-1
      invoke GetDlgItemText,hWnd,id+22,addr buf2,MAX_PATH-1
      invoke SetDlgItemText,hWnd,id+12,addr buf2
      invoke SetDlgItemText,hWnd,id+22,addr buf

      invoke GetDlgItemText,hWnd,id+5,addr buf,MAX_PATH-1
      invoke GetDlgItemText,hWnd,id+6,addr buf2,MAX_PATH-1
      invoke SetDlgItemText,hWnd,id+5,addr buf2
      invoke SetDlgItemText,hWnd,id+6,addr buf

      invoke SetCaption,hWnd    
    .endif

  .elseif wParam==id+44  ; "\\"
    invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1
    invoke BackSlash,hWnd,addr buf
    invoke SetDlgItemText,hWnd,id+10,addr buf
    invoke SetDlgItemText,hWnd,id+70,addr buf
    invoke GetDlgItemText,hWnd,id+20,addr buf,MAX_PATH-1
    invoke BackSlash,hWnd,addr buf
    invoke SetDlgItemText,hWnd,id+20,addr buf

  .elseif wParam==id+39  ; "show count"
    invoke IsDlgButtonChecked,hWnd,id+39
    mov ch39,eax
    
  .else
    xor eax,eax
    jmp @f
    
  .endif
  xor eax,eax
  inc eax
@@:
  ret
OnCommand endp

;===================================================================

OnSysCommand proc uses ebx edi esi hWnd:HWND,wParam:WPARAM,lParam:LPARAM

  local cbi:COMBOBOXINFO_
  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR

  .if wParam==SC_CUSTOM+10h       ; Init+Rerun

    invoke GetStringFileName,61,addr buf
    invoke DeleteFile,addr buf
    jmp @f

  .elseif  wParam==SC_CUSTOM+20h  ; Save+Rerun

    invoke GetStringFileName,61,addr buf
    invoke SaveSettings,hWnd,addr buf
@@:
    invoke GetModuleFileName,0,addr buf,MAX_PATH-1
;    invoke ShellExecute,0,0,addr buf,0,0,SW_SHOWNORMAL
    invoke CreateProc,addr buf,NORMAL_PRIORITY_CLASS,40
    invoke DeleteObject,hbrush
    invoke EndDialog,hWnd,0

  .elseif wParam==SC_CUSTOM+40h   ; Erase

    xor ebx,ebx
    jmp @f

  .elseif wParam==SC_CUSTOM+50h   ; Clear
             
    xor ebx,ebx
    inc ebx
@@:
    .if hThread2==0 && hThread3==0
      invoke ClearProc,hWnd,ebx
    .else
      invoke BeepThreadIf,hWnd,beep_lo
    .endif

  .elseif wParam==SC_CUSTOM+70h   ; +/- Translucency (no-hole)

    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    xor eax,WS_EX_LAYERED
    mov ebx,eax
    and eax,WS_EX_LAYERED
    mov edi,eax
    mov esi,id+60
    .while esi<=id+61
      invoke RtlZeroMemory,addr cbi,sizeof cbi
      mov cbi.cbSize,sizeof cbi
      invoke GetDlgItem,hWnd,esi
      mov edx,eax
      invoke GetComboBoxInfo,edx,addr cbi
      invoke GetWindowLong,cbi.hwndList,GWL_EXSTYLE
      .if edi==0
        and eax,not WS_EX_LAYERED
      .else
        or eax,WS_EX_LAYERED
      .endif
      invoke SetWindowLong,cbi.hwndList,GWL_EXSTYLE,eax
      invoke SetWindowPos,cbi.hwndList,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
      invoke SetLayeredWindowAttributes,cbi.hwndList,0,alpha,LWA_ALPHA
      inc esi
    .endw
    .if edi==0
      mov edi,MF_UNCHECKED
    .else
      mov edi,MF_CHECKED
    .endif   
    invoke GetSystemMenu,hWnd,0
    mov esi,eax
    invoke CheckMenuItem,esi,wParam,edi
    .if edi==MF_UNCHECKED
      mov edx,wParam
      add edx,10h
      invoke CheckMenuItem,esi,edx,edi
    .endif
    mov eax,ebx
    jmp @f

  .elseif wParam==SC_CUSTOM+80h   ; + Transparency (Hole)

    invoke SetTimer,hWnd,4,100,0
    invoke RtlZeroMemory,addr cbi,sizeof cbi
    mov cbi.cbSize,sizeof cbi
    invoke GetDlgItem,hWnd,id+61
    mov edx,eax
    invoke GetComboBoxInfo,edx,addr cbi
    invoke GetWindowLong,cbi.hwndList,GWL_EXSTYLE
    or eax,WS_EX_TRANSPARENT or WS_EX_LAYERED
    invoke SetWindowLong,cbi.hwndList,GWL_EXSTYLE,eax
    invoke SetWindowPos,cbi.hwndList,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    invoke SetLayeredWindowAttributes,cbi.hwndList,0,alpha,LWA_ALPHA
    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    or eax,WS_EX_TRANSPARENT or WS_EX_LAYERED
    mov ebx,eax
    invoke GetSystemMenu,hWnd,0
    mov edi,eax
    invoke CheckMenuItem,edi,wParam,MF_CHECKED
    mov eax,wParam
    sub eax,10h
    invoke CheckMenuItem,edi,eax,MF_CHECKED
    mov eax,ebx
@@:    
    invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
    invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    invoke SetLayeredWindowAttributes,hWnd,0,alpha,LWA_ALPHA

  .elseif wParam==SC_CUSTOM+0a0h

    xor uacdd,1
    invoke GetSystemMenu,hWnd,0
    .if uacdd==0
      mov edx,MF_UNCHECKED
    .else
      mov edx,MF_CHECKED
    .endif
    invoke CheckMenuItem,eax,wParam,edx
    invoke DragDropUAC,hWnd,uacdd
    invoke InvalidateRect,hWnd,0,1

  .elseif wParam==SC_CUSTOM+0c0h

    invoke BeepThreadIf,hWnd,beep_lo
    invoke LoadString,hinst,54,addr buf,MAX_PATH-1
;;    invoke ShellExecute,0,0,addr buf,0,0,SW_SHOWNORMAL
    fn lstrcat,addr buf," /"
    invoke CreateProc,addr buf,NORMAL_PRIORITY_CLASS,0
    invoke BeepThreadIf,hWnd,beep_hi
  .else
    xor eax,eax
    jmp @f
  .endif
  xor eax,eax
  inc eax
@@:  
  ret
OnSysCommand endp

;===================================================================

OnPaint proc uses ebx edi esi hWnd:HWND

  local ps:PAINTSTRUCT
  local rt:RECT

  invoke BeginPaint,hWnd,addr ps
  mov ebx,eax
  invoke GetDlgItem,hWnd,id+27
  mov edx,eax
  invoke GetWindowRect,edx,addr rt
  mov edi,rt.left
  mov esi,rt.top
  invoke GetDlgItem,hWnd,id+34
  mov edx,eax
  invoke GetWindowRect,edx,addr rt
  mov rt.left,edi
  mov rt.top,esi
  invoke MapWindowPoints,0,hWnd,addr rt,2
  sub rt.top,2
  sub rt.left,2
  add rt.right,2
  add rt.bottom,2
  invoke FrameRect,ebx,addr rt,hbrush
  invoke EndPaint,hWnd,addr ps
  ret
OnPaint endp

;===================================================================

OnInit proc uses ebx edi esi hWnd:HWND

  local mii:MENUITEMINFO
  local cbi:COMBOBOXINFO_
  local li:LARGE_INTEGER_
  local var:DWORD
  local rt:RECT
  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR

  invoke GetWindowRect,hWnd,addr rt
  mov eax,rt.right
  sub eax,rt.left
  mov xsize,eax

  mov edi,id+25
  .while edi<=id+28
    .if edi<=id+26
      mov eax,2
    .else
      mov eax,8
    .endif
    invoke SendDlgItemMessage,hWnd,edi,EM_SETLIMITTEXT,eax,0
    inc edi
  .endw

  mov edi,id+1
  .while edi<=id+29
    invoke GetDlgItem,hWnd,edi
    mov ebx,eax
    .if edi<=id+22
      invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubClass
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
    .elseif edi>=id+24 && edi<=id+29
      invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubClass2
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
    .endif
    invoke GetWindowLong,ebx,GWL_STYLE
    or eax,WS_BORDER
    invoke SetWindowLong,ebx,GWL_STYLE,eax
    invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    inc edi
  .endw

  mov edi,id+60
  .while edi<=id+61
    invoke GetDlgItem,hWnd,edi
    mov ebx,eax
    invoke GetWindowLong,ebx,GWL_EXSTYLE
    or eax,WS_EX_LAYOUTRTL
    invoke SetWindowLong,ebx,GWL_EXSTYLE,eax
    invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    invoke RtlZeroMemory,addr cbi,sizeof cbi
    mov cbi.cbSize,sizeof cbi
    invoke GetComboBoxInfo,ebx,addr cbi
    invoke SetWindowLong,cbi.hwndItem,GWL_WNDPROC,offset SubClass2
    invoke SetWindowLong,cbi.hwndItem,GWL_USERDATA,eax
    inc edi
  .endw

  invoke GetDlgItem,hWnd,id+60
  mov ebx,eax
  xor edi,edi
  .while TRUE
    mov edx,edi
    add edx,ii
    invoke LoadString,hinst,edx,addr buf,MAX_PATH-1
  .break .if eax==0
    .if edi>=3
      lea edx,buf
      .while TCHAR ptr[edx]!='('
        add edx,sizeof TCHAR
      .endw
      mov TCHAR ptr[edx],0
    .endif
    invoke SendMessage,ebx,CB_ADDSTRING,0,addr buf
    add edi,4
  .endw

  invoke StringToLog,offset _next
  invoke QueryPerformanceFrequency,addr li
  invoke LoadString,hinst,29,addr buf,MAX_PATH-1
  invoke wsprintf,addr buf2,addr buf,li.HighPart,li.LowPart
  invoke StringToLog,addr buf2
  invoke SendDlgItemMessage,hWnd,id+61,CB_ADDSTRING,0,addr buf2
  invoke LoadString,hinst,27,addr buf,MAX_PATH-1
  invoke StringToLog,addr buf
  invoke SendDlgItemMessage,hWnd,id+61,CB_ADDSTRING,0,addr buf

  invoke CheckDlgButton,hWnd,id+32,BST_CHECKED
  invoke CheckDlgButton,hWnd,id+37,BST_CHECKED
  invoke CheckDlgButton,hWnd,id+38,BST_CHECKED
  mov eax,BST_UNCHECKED
  mov ch39,eax  
  invoke CheckDlgButton,hWnd,id+39,eax

  mov ebx,36
  .while ebx<=38
    invoke LoadString,hinst,ebx,addr buf,MAX_PATH-1
    invoke StrToInt,addr buf
    push eax
    inc ebx
  .endw
  pop beep_ms
  pop beep_lo
  pop beep_hi

  mov procN,1
  mov dwCreationDisposition,2
  mov alpha,200

  invoke ClearProc,hWnd,0  

  invoke GetModuleFileName,0,addr buf,MAX_PATH-1
  invoke PathRemoveExtension,addr buf
  invoke LoadString,hinst,61,addr buf2,MAX_PATH-1
  invoke lstrcat,addr buf,addr buf2
  invoke RestoreSettings,hWnd,addr buf

  mov edx,procN
  .if edx==1
    invoke GetAllocGran
    fn wsprintf,addr buf,"%8.8lX",eax
  .else
    add edx,edx
    add edx,edx
    add edx,ii
    inc edx
    invoke LoadString,hinst,edx,addr buf,MAX_PATH-1
  .endif
  invoke SetDlgItemText,hWnd,id+29,addr buf

  invoke SetCaption,hWnd

  invoke GetSystemMenu,hWnd,0
  mov ebx,eax

  invoke LoadString,hinst,55,addr buf,MAX_PATH-1
  invoke ModifyMenu,ebx,SC_CLOSE,MF_BYCOMMAND or MF_STRING,SC_CLOSE,addr buf

  invoke RtlZeroMemory,addr mii,sizeof mii
  mov mii.cbSize,sizeof mii
  mov mii.fMask,MIIM_BITMAP
  mov mii.fType,MFT_BITMAP
  mov eax,HBMMENU_MBAR_CLOSE
  mov mii.hbmpItem,eax
  invoke SetMenuItemInfo,ebx,SC_CLOSE,0,addr mii

  xor edi,edi
  .while TRUE
    .if edi==0 || edi==3 || edi==6 || edi==9 || edi==11
      invoke AppendMenu,ebx,MF_SEPARATOR,0,0
    .else
      mov edx,40
      add edx,edi
      invoke LoadString,hinst,edx,addr buf,MAX_PATH-1
  .break .if eax==0
      mov edx,edi
      shl edx,4
      add edx,0e000h
      invoke AppendMenu,ebx,MF_STRING,edx,addr buf
    .endif
    inc edi
  .endw

  xor edi,edi
  .while TRUE
    mov edx,edi
    add edx,edx
    add edx,edx
    add edx,ii
    invoke LoadString,hinst,edx,addr buf,MAX_PATH-1
  .break .if eax==0
    inc edi
  .endw
  mov procMax,edi
;
  mov var,5555AAAAh                     ; chess
  invoke CreateBitmap,2,2,1,1,addr var
  push eax
  invoke CreatePatternBrush,eax
  mov hbrush,eax
;  pop eax
;  push eax
;  invoke CopyImage,eax,IMAGE_BITMAP,8,8,LR_MONOCHROME
;  push eax
;  invoke CreatePatternBrush,eax
;  mov hbrush_8,eax
;  call DeleteObject
  call DeleteObject
;
  invoke LoadIcon,hinst,1
  invoke SetClassLong,hWnd,GCL_HICON,eax
;
  invoke GetCommandLine
  invoke PathGetArgs,eax
  mov ebx,eax
  invoke lstrlen,ebx
  .if eax!=0
    invoke PathUnquoteSpaces,ebx
    invoke SetDlgItemText,hWnd,id+10,ebx
    invoke SetDlgItemText,hWnd,id+70,ebx
    invoke SendDlgItemMessage,hWnd,id+31,BM_CLICK,0,0
  .endif
;
  ret
OnInit endp

;===================================================================

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local pt:POINT
  local rt:RECT
  local buf[MAX_PATH]:TCHAR
  local buf2[MAX_PATH]:TCHAR
  local buf3[MAX_PATH]:TCHAR

;-----------------------------------------------------------------
  .if uMsg==WM_DROPFILES && hThread2!=0

    invoke BeepThreadIf,hWnd,beep_lo

  .elseif uMsg==WM_DROPFILES && hThread2==0

    inc droped
    invoke DragQueryFile,wParam,0,addr buf,MAX_PATH-1
    invoke BackSlash,hWnd,addr buf
    invoke DragFinish,wParam
    invoke BeepIf,hWnd,beep_hi,beep_ms
;    invoke ClearProc,hWnd,1
    invoke GetCursorPos,addr pt
    invoke GetDlgItem,hWnd,id+20
    mov edx,eax
    invoke GetWindowRect,edx,addr rt
    mov eax,pt.y
    .if eax>=rt.top
      mov edi,id+20
      mov ebx,id+10
    .else
@@:
      mov edi,id+10
      mov ebx,id+20
    .endif

    invoke IsDlgButtonChecked,hWnd,id+38
    test eax,eax
    jz @@@

;    invoke PathIsDirectory,addr buf  ; unworkable
    invoke GetFileAttributes,addr buf
    .if eax==INVALID_FILE_ATTRIBUTES
      mov esi,7                                             ; "-- Func error"
    .else
      and eax,FILE_ATTRIBUTE_DIRECTORY
      .if eax!=0
        mov esi,6                                           ; "-- File!=Directory"
      .else
        invoke RtlZeroMemory,addr L_I,sizeof L_I
        invoke FileSizeEx,addr buf,addr L_I
        .if eax==1
          mov esi,4                                         ; "-- FileSize error"
        .elseif eax==2
          mov esi,5                                         ; "-- INVALID_HANDLE_VALUE"
        .else ;(if eax==0)
          fn wsprintf,addr buf3,"%8.8lX",L_I.HighPart
          inc edi
          invoke SetDlgItemText,hWnd,edi,addr buf3

          invoke IsDlgButtonChecked,hWnd,id+37
          .if eax==BST_UNCHECKED
            invoke SetDlgItemText,hWnd,id+27,addr buf3
          .endif

          fn wsprintf,addr buf3,"%8.8lX",L_I.LowPart
          inc edi
          invoke SetDlgItemText,hWnd,edi,addr buf3

          invoke IsDlgButtonChecked,hWnd,id+37
          .if eax==BST_UNCHECKED
            invoke SetDlgItemText,hWnd,id+28,addr buf3
            invoke SetDlgItemText,hWnd,id+24,addr buf
            invoke ReadFirstLastByte,hWnd,addr buf
          .endif

          dec edi
          dec edi
          invoke GetDlgItemText,hWnd,ebx,addr buf2,MAX_PATH-1
          .if eax==0
            mov esi,8                                       ; "-- Empty File error"
          .else
            push L_I.LowPart
            push L_I.HighPart
            invoke RtlZeroMemory,addr L_I,sizeof L_I
            invoke FileSizeEx,addr buf2,addr L_I
            .if eax==1
              mov esi,4                                     ; "-- FileSize error"
              pop eax
              pop eax
            .elseif eax==2
              mov esi,5                                     ; "-- INVALID_HANDLE_VALUE"
              pop eax
              pop eax
            .else
              fn wsprintf,addr buf3,"%8.8lX",L_I.HighPart
              inc ebx
              invoke SetDlgItemText,hWnd,ebx,addr buf3
              fn wsprintf,addr buf3,"%8.8lX",L_I.LowPart
              inc ebx
              invoke SetDlgItemText,hWnd,ebx,addr buf3
              dec ebx
              dec ebx
              pop ecx
              pop edx
              .if ecx!=L_I.HighPart || edx!=L_I.LowPart
                mov esi,13                                  ; "!= NotEqualSize"
              .else
                xor esi,esi                                 ; ""  ; =0
              .endif
            .endif
            invoke lstrcmpi,addr buf,addr buf2
            .if eax==0
              mov esi,10                                    ; "-- Same File"
            .endif
          .endif
        .endif
      .endif
    .endif
    invoke SetDlgItemText,hWnd,edi,addr buf
    .if edi==id+10
      invoke SetDlgItemText,hWnd,id+70,addr buf
    .endif

    invoke IsDlgButtonChecked,hWnd,id+37                    ; choose compare/#top->[CreateFile] 
    .if eax==BST_CHECKED && (esi==0 || (droped==0 && esi==10))
@@@:
      invoke FileToLog,hWnd
      invoke CreateThread,0,0,offset ThreadProc,hWnd,0,0
      mov hThread2,eax
    .else
      invoke BeepIf,hWnd,beep_lo,beep_ms
    .endif
    xor eax,eax
    mov droped,eax
    invoke LoadString,hinst,esi,addr buf,MAX_PATH-1
    invoke SetDlgItemText,hWnd,id+2,addr buf
    lea edx,buf
    mov TCHAR ptr[edx+2*sizeof(TCHAR)],0    
    invoke SetDlgItemText,hWnd,id+3,addr buf
    invoke RedrawWindow,hWnd,0,0,RDW_UPDATENOW or RDW_INVALIDATE ; or RDW_ALLCHILDREN
;-----------------------------------------------------------------
  .elseif uMsg==WM_COMMAND 
  
    .if wParam==id+31
      .if hThread2==0
        invoke BeepIf,hWnd,beep_hi,beep_ms
;        invoke ClearProc,hWnd,1
        invoke GetDlgItemText,hWnd,id+20,addr buf,MAX_PATH-1
        invoke BackSlash,hWnd,addr buf
        invoke SetDlgItemText,hWnd,id+20,addr buf
        invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1
        invoke BackSlash,hWnd,addr buf        
        invoke SetDlgItemText,hWnd,id+10,addr buf
        invoke SetDlgItemText,hWnd,id+70,addr buf
        jmp @b
      .else
        invoke BeepThreadIf,hWnd,beep_lo
      .endif
    .else
      invoke OnCommand,hWnd,wParam,lParam
      jmp @ret
    .endif
;-----------------------------------------------------------------
  .elseif uMsg==WM_PAINT

    invoke OnPaint,hWnd
;-----------------------------------------------------------------
  .elseif uMsg==WM_CTLCOLORSTATIC || uMsg==WM_CTLCOLORDLG || uMsg==WM_CTLCOLOREDIT

    invoke SetBkMode,wParam,TRANSPARENT
    invoke GetDlgCtrlID,lParam
    .if eax==id+20 || eax==id+21 || eax==id+22 
      mov edi,White
      mov esi,BLACK_BRUSH

    .elseif eax==id+4 || eax==id+13
      invoke SetTextColor,wParam,Blue
      invoke GetSysColorBrush,COLOR_MENU
      jmp @ret

    .elseif eax==id+3
      .if uacdd==0
        jmp @f
      .endif

    .else
@@:
      mov edi,Black
      mov esi,WHITE_BRUSH

    .endif
    invoke SetTextColor,wParam,edi
    invoke GetStockObject,esi
    jmp @ret
;-----------------------------------------------------------------
  .elseif uMsg==WM_TIMER

    invoke OnTimer,hWnd,wParam,lParam
    jmp @ret
;-----------------------------------------------------------------
  .elseif uMsg==WM_LBUTTONDOWN

    mov eax,SC_SIZE+9
    invoke PostMessage,hWnd,WM_SYSCOMMAND,eax,0
;-----------------------------------------------------------------
  .elseif uMsg==WM_LBUTTONDBLCLK

    invoke GetWindowRect,hWnd,addr rt
    invoke GetSystemMetrics,SM_CXSCREEN
    mov ecx,rt.right
    sub ecx,rt.left
    mov edx,rt.bottom
    sub edx,rt.top
    .if eax!=rt.right
      sub eax,rt.left
      mov xsize,ecx
    .else
      mov eax,xsize
    .endif
    invoke SetWindowPos,hWnd,0,0,0,eax,edx,SWP_NOMOVE or SWP_FRAMECHANGED or SWP_NOZORDER
;-----------------------------------------------------------------
  .elseif uMsg==WM_NCLBUTTONDBLCLK  ; Rectangle (left|right/back)
  
    xor minim,1
    .if minim!=0
      invoke GetWindowRect,hWnd,addr rect
      invoke GetSystemMetrics,SM_CXSMSIZE
      push eax
      invoke GetSystemMetrics,SM_CXSCREEN
      mov esi,eax
      invoke GetSystemMetrics,SM_CYSCREEN
      mov edi,eax
      invoke GetSystemMetrics,SM_CYSIZEFRAME
      mov ebx,eax
      add ebx,ebx
      add edi,ebx
      neg eax
      mov edx,rect.right
      sub edx,rect.left
      shr edx,1
      add edx,rect.left
      mov ecx,lParam
      and ecx,0ffffh
      pop ebx      
      .if ecx<=edx
        mov ecx,eax
      .else
        mov ecx,eax
        sub esi,ebx
        sub esi,ebx
        mov eax,esi
      .endif
      xor ebx,ebx
    .else
      mov eax,rect.left
      mov ecx,rect.top
      mov ebx,rect.right
      sub ebx,rect.left
      mov edi,rect.bottom
      sub edi,rect.top
    .endif
    invoke SetWindowPos,hWnd,HWND_TOPMOST,eax,ecx,ebx,edi,SWP_FRAMECHANGED
;-----------------------------------------------------------------
  .elseif uMsg==WM_NCMBUTTONUP
  
    invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_CUSTOM+80h,0
;-----------------------------------------------------------------
  .elseif uMsg==WM_SYSCOMMAND

    invoke OnSysCommand,hWnd,wParam,lParam
    jmp @ret
;-----------------------------------------------------------------
  .elseif uMsg==WM_ENTERIDLE && wParam==MSGF_MENU && lParam!=0

    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    and eax,WS_EX_LAYERED
    .if eax!=0
      invoke GetWindowLong,lParam,GWL_EXSTYLE
      mov edx,eax
      or eax,WS_EX_LAYERED
      .if eax!=edx
        invoke SetWindowLong,lParam,GWL_EXSTYLE,eax
        invoke SetWindowPos,lParam,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE      
        invoke SetLayeredWindowAttributes,lParam,0,alpha,LWA_ALPHA
      .endif  
    .endif
;-----------------------------------------------------------------
  .elseif uMsg==WM_MOUSEWHEEL

    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    and eax,WS_EX_LAYERED
    .if eax!=0
      mov eax,wParam
      shr eax,24
      .if al==00h
        inc alpha
        .if alpha>255
          mov alpha,255
        .endif
      .elseif al==0ffh
        dec alpha
        .if alpha<1
          mov alpha,1
        .endif
      .endif
      invoke SetLayeredWindowAttributes,hWnd,0,alpha,LWA_ALPHA
    .endif
;-----------------------------------------------------------------
  .elseif uMsg==WM_INITDIALOG

    invoke OnInit,hWnd
;-----------------------------------------------------------------
  .elseif uMsg==WM_SIZE

    invoke OnSize,hWnd,lParam
    invoke SetCaption,hWnd
    invoke RedrawWindow,hWnd,0,0,RDW_UPDATENOW or RDW_INVALIDATE ; or RDW_ALLCHILDREN
;-----------------------------------------------------------------
  .elseif uMsg==WM_CLOSE

    .if minim!=0
      mov eax,rect.right
      sub eax,rect.left
      mov edx,rect.bottom
      sub edx,rect.top
      invoke SetWindowPos,hWnd,0,rect.left,rect.top,eax,edx,SWP_FRAMECHANGED or SWP_HIDEWINDOW
    .endif
    invoke GetStringFileName,61,addr buf
    invoke SaveSettings,hWnd,addr buf
    invoke DeleteObject,hbrush
    invoke EndDialog,hWnd,0
;-----------------------------------------------------------------
;  .elseif uMsg==WM_CONTEXTMENU
;
;    invoke GetDlgCtrlID,wParam
;    .if eax==id+44
;      invoke GetDlgItemText,hWnd,id+10,addr buf,MAX_PATH-1
;      invoke GetDlgItemText,hWnd,id+70,addr buf2,MAX_PATH-1
;      invoke MoveFile,addr buf2,addr buf
;      invoke SetDlgItemText,hWnd,id+70,addr buf
;    .endif
;    jmp @0
;-----------------------------------------------------------------
  .elseif uMsg==WM_SETCURSOR
  
    invoke OnSetCursor,hWnd,wParam,lParam
    jmp @ret
;-----------------------------------------------------------------
  .else
@0:
    xor eax,eax
    jmp @ret
  .endif
;-----------------------------------------------------------------
  xor eax,eax
  inc eax
@ret:
  ret
DlgProc endp

;===================================================================

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  invoke ExitProcess,0
  invoke InitCommonControls
end start

;===================================================================
